// Squawk messenger. 
// Copyright (C) 2019  Yury Gubich <blue@macaw.me>
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef CORE_VCARDHANDLER_H
#define CORE_VCARDHANDLER_H

#include <set>

#include <QXmppVCardIq.h>
#include <QXmppPresence.h>

#include <QObject>

#include <shared/vcard.h>
#include <core/adapterfunctions.h>

/**
 * @todo write docs
 */

namespace Core {

class Account;

class VCardHandler : public QObject
{
    Q_OBJECT
public:
    VCardHandler(Account* account);
    ~VCardHandler();

    void handleOffline();
    void requestVCard(const QString& jid);
    void handleOtherPresenceOfMyAccountChange(const QXmppPresence& p_presence);
    void uploadVCard(const Shared::VCard& card);
    QString getAvatarPath() const;

private slots:
    void onVCardReceived(const QXmppVCardIq& card);
    void onOwnVCardReceived(const QXmppVCardIq& card);

private:
    Account* acc;

    bool ownVCardRequestInProgress;
    std::set<QString> pendingVCardRequests;
    QString avatarHash;
    QString avatarType;
};
}

#endif // CORE_VCARDHANDLER_H
